<%-- $Id: edit_client.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.CLIENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Client client = null;

	if (itemId == 0)
	{
		title = "Create client application";
		cc.removeObject("item");
	}
	else
	{
		client = Client.getById(dc, itemId);
		cc.setObject("item", client);
		title = "Edit client application -- " + HTML.encodeTags(client.getName());
	}
	if (client != null && !client.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Client" tab
		function validateClient()
		{
			var frm = document.forms['client'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['client'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (client == null)
			{
				%>
				var frm = document.forms['client'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="client" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*160)+"px;"%>" 
			position="bottom"  remember="<%=client != null%>">
		<t:tab id="info" title="Client application" validate="validateClient()" helpid="client.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(client == null ? Values.getString(cc.getPropertyValue("name"), "New client application") : client.getName())%>" 
					size="40" maxlength="<%=Client.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External Id</td>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(client == null ? cc.getPropertyValue("externalId") : client.getExternalId())%>" 
					size="40" maxlength="<%=Client.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(client == null ? cc.getPropertyValue("description") : client.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'client', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
