<%-- $Id: index.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"	
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.DatabaseException"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,login,expirationDate,groups,roles,email,description");
	private static final Item itemType = Item.USER;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_users.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_user.jsp?ID="+ID;
final String editPage = "edit_user.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		redirect = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		dc = sc.newDbControl();
		
		final String email = Values.getStringOrNull(request.getParameter("email"));
		if (email != null && !HTML.isValidEmail(email))
		{
			throw new WebException("popup", "Invalid email address",
				"The email address {1} is not a valid email address.",
				HTML.encodeTags(email)
			);
		}
		final String login = Values.getStringOrNull(request.getParameter("login"));
		final String password = Values.getStringOrNull(request.getParameter("new_password"));
		String oldLogin = null;		
		String oldExternalId = null;
		boolean loginHasChanged = true;
		boolean externalIdHasChanged = false;

		User user = (User)cc.getObject("item");
		if (user == null)
		{
			user = User.getNew(dc, login, password);
			user.addToDefaultRolesAndGroups();
			message = "User created";
			dc.saveItem(user);
		}
		else
		{
			dc.reattachItem(user);
			oldLogin = user.getLogin();
			user.setLogin(login);
			loginHasChanged = oldLogin != login;
			if (password != null) user.setPassword(password);
			message = "User updated";
		}
		user.setName(Values.getStringOrNull(request.getParameter("name")));
		oldExternalId = user.getExternalId();
		user.setExternalId(Values.getStringOrNull(request.getParameter("external_id")));
		externalIdHasChanged = oldExternalId != user.getExternalId();

		int quotaId = Values.getInt(request.getParameter("quota_id"), -1);
		if (quotaId >= 0) // < 0 = denied or unchanged
		{
			user.setQuota(quotaId == 0 ? null : Quota.getById(dc, quotaId));
		}
		int quotaGroupId = Values.getInt(request.getParameter("quotagroup_id"), -1);
		if (quotaGroupId >= 0) // < 0 = denied or unchanged
		{
			user.setQuotaGroup(quotaGroupId == 0 ? null : Group.getById(dc, quotaGroupId));
		}
		String homeDirectory = request.getParameter("homedirectory_id");
		if ("new".equals(homeDirectory))
		{
			Directory.createHomeDirectory(dc, user, false);
		}
		else if ("template".equals(homeDirectory))
		{
			Directory.createHomeDirectory(dc, user, true);
		}
		else
		{
			int homeDirectoryId = Values.getInt(homeDirectory, -1);
			if (homeDirectoryId >= 0) // < 0 = denied or unchanged
			{
				user.setHomeDirectory(homeDirectoryId == 0 ? null : Directory.getById(dc, homeDirectoryId));
			}
		}
		
		Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
		user.setExpirationDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("expiration_date"))));
		user.setMultiuserAccount(Values.getBoolean(request.getParameter("multiuser_account")));
		user.setDisabled(Values.getBoolean(request.getParameter("disabled")));
		
		// Contact information
		user.setEmail(email);
		user.setOrganisation(Values.getStringOrNull(request.getParameter("organisation")));
		user.setAddress(Values.getStringOrNull(request.getParameter("address")));
		user.setPhone(Values.getStringOrNull(request.getParameter("phone")));
		user.setFax(Values.getStringOrNull(request.getParameter("fax")));
		user.setUrl(Values.getStringOrNull(request.getParameter("url")));
		user.setDescription(Values.getStringOrNull(request.getParameter("description")));
		
		// Extended properties
		List<ExtendedProperty> extendedProperties = ExtendedProperties.getProperties("UserData");
		if (extendedProperties != null)
		{
			for (ExtendedProperty ep : extendedProperties)
			{
				String name = ep.getName();
				Object value = ep.getType().parseString(Values.getStringOrNull(request.getParameter(name)));
				user.setExtended(name, value);
			}
		}

		// Membership
		String[] removeGroups = Values.getString(request.getParameter("removeGroups")).split(",");
		for (int i = 0; i < removeGroups.length; ++i)
		{
			int groupId = Values.getInt(removeGroups[i], -1);
			if (groupId != -1) Group.getById(dc, groupId).removeUser(user);
		}
		
		String[] addGroups = Values.getString(request.getParameter("addGroups")).split(",");
		for (int i = 0; i < addGroups.length; ++i)
		{
			int groupId = Values.getInt(addGroups[i], -1);
			if (groupId != -1) Group.getById(dc, groupId).addUser(user);
		}

		String[] removeRoles = Values.getString(request.getParameter("removeRoles")).split(",");
		for (int i = 0; i < removeRoles.length; ++i)
		{
			int roleId = Values.getInt(removeRoles[i], -1);
			if (roleId != -1) Role.getById(dc, roleId).removeUser(user);
		}
		
		String[] addRoles = Values.getString(request.getParameter("addRoles")).split(",");
		for (int i = 0; i < addRoles.length; ++i)
		{
			int roleId = Values.getInt(addRoles[i], -1);
			if (roleId != -1) Role.getById(dc, roleId).addUser(user);
		}
		try
		{
			dc.commit();
		}
		catch (DatabaseException dbex)
		{
			dc = sc.newDbControl();
			if (loginHasChanged && login != null && !login.equals(oldLogin) && User.loginIsUsed(dc, login))
			{
				throw new ItemAlreadyExistsException("User[login=" + login + "]");
			}
			String externalId = Values.getStringOrNull(request.getParameter("external_id"));
			if (externalIdHasChanged && externalId != null && !externalId.equals(oldExternalId) && User.externalIdIsUsed(dc, externalId))
			{
				throw new ItemAlreadyExistsException("User[externalId=" + externalId + "]");
			}
			throw dbex;
		}
		cc.removeObject("item");
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<User> query = User.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+users";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+user";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<User> query = User.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+users";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+user";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<User> query = User.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("EditDefaultMembership".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		forward = "edit_default_membership.jsp";
	}
	else if ("UpdateDefaultMembership".equals(cmd))
	{
		dc = sc.newDbControl();
		// Membership
		String[] removeGroups = Values.getString(request.getParameter("removeGroups")).split(",");
		for (int i = 0; i < removeGroups.length; ++i)
		{
			int groupId = Values.getInt(removeGroups[i], -1);
			if (groupId != -1) Group.getById(dc, groupId).setDefault(false);
		}
		
		String[] addGroups = Values.getString(request.getParameter("addGroups")).split(",");
		for (int i = 0; i < addGroups.length; ++i)
		{
			int groupId = Values.getInt(addGroups[i], -1);
			if (groupId != -1) Group.getById(dc, groupId).setDefault(true);
		}

		String[] removeRoles = Values.getString(request.getParameter("removeRoles")).split(",");
		for (int i = 0; i < removeRoles.length; ++i)
		{
			int roleId = Values.getInt(removeRoles[i], -1);
			if (roleId != -1) Role.getById(dc, roleId).setDefault(false);
		}
		
		String[] addRoles = Values.getString(request.getParameter("addRoles")).split(",");
		for (int i = 0; i < addRoles.length; ++i)
		{
			int roleId = Values.getInt(addRoles[i], -1);
			if (roleId != -1) Role.getById(dc, roleId).setDefault(true);
		}
		dc.commit();
	}

	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

