<%-- $Id: share.jsp 4587 2008-10-15 14:40:47Z martin $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@param item The type of items in the table

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemKey"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.ProjectKey"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.EnumSet"
	import="java.util.Set"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getPermissionString(Set<Permission> permissions)
{
	StringBuilder sb = new StringBuilder();
	sb.append(permissions.contains(Permission.READ) ? "R" : "-");
	sb.append(permissions.contains(Permission.USE) ? "U" : "-");
	sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
	sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
	sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
	sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
	return sb.toString();
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");

final DbControl dc = sc.newDbControl();
ItemResultIterator<User> users = null;
ItemResultIterator<Group> groups = null;
ItemResultIterator<Project> projects = null;
try
{
	MultiPermissions mp = (MultiPermissions)sc.getCurrentContext(itemType, subContext).getObject("MultiPermissions");
	if (mp == null)
	{
		throw new WebException("popup", "Item not found", "No MultiPermissions object found for item: " + itemType);
	}

	// Query to retrieve users
	final ItemQuery<User> userQuery = mp.getUsers();
	userQuery.order(Orders.asc(Hql.property("name")));

	// Query to retrieve groups
	final ItemQuery<Group> groupQuery = mp.getGroups();
	groupQuery.order(Orders.asc(Hql.property("name")));

	// Query to retrieve projects
	final ItemQuery<Project> projectQuery = mp.getProjects();
	projectQuery.order(Orders.asc(Hql.property("name")));
	
	final boolean writePermission = true;
	
	/*
	 	Set the headline with the item's name or, 
	 	if there are more then one item, the text 'multiple item'
	*/
	String headLine = "";
	Set<SharedItem> currentItems = mp.getItems();
	if(currentItems.size() == 1)
	{
		SharedItem item = currentItems.iterator().next();  
		if(item instanceof Nameable)
		{
			headLine = "Set access permissions -- " + HTML.encodeTags(((Nameable)item).getName());
		}
		else
		{
			headLine = "Set access permissions -- " + HTML.encodeTags(item.toString());
		}
	}
	else
	{
		headLine = "Set access permissions -- Multiple items (" + currentItems.size() + ")";
	}
	boolean hasDirectory = mp.getItems(Item.DIRECTORY).size() > 0;

	%>
	<base:page type="popup" title="Set access permissions">
	<base:head scripts="linkitems.js" >
		<script language="JavaScript">
		var share_to_everyone = <%=sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE)%>;
		var everyone_id = <%=SystemItems.getId(Group.EVERYONE)%>;
		function initList()
		{
			var members = document.forms['share'].members;
			Link.addNewSection(members, new Section('U', 'Users'));
			<%
			users = userQuery.iterate(dc);
			while (users.hasNext())
			{
				User user = users.next();
				Map<ItemKey, Set<Permission>> p = mp.getPermissions(user);
				String permissionString = "varying";
				int permissionCode = 0;
				if (MultiPermissions.allSame(p.values()))
				{
					Set<Permission> first = p.values().iterator().next();
					permissionString = getPermissionString(first);
					permissionCode = PermissionUtil.getPermissionCode(first);
				}
				%>
				Link.addNewItem(members, new Item('U', <%=user.getId()%>, '<%=HTML.javaScriptEncode(user.getName())%> [<%=permissionString%>]', <%=permissionCode%>));
				<%
			}
			%>
			Link.addNewSection(members, new Section('G', 'Groups'));
			<%
			groups = groupQuery.iterate(dc);
			while (groups.hasNext())
			{
				Group group = groups.next();
				Map<ItemKey, Set<Permission>> p = mp.getPermissions(group);
				String permissionString = "varying";
				int permissionCode = 0;
				if (MultiPermissions.allSame(p.values()))
				{
					Set<Permission> first = p.values().iterator().next();
					permissionString = getPermissionString(first);
					permissionCode = PermissionUtil.getPermissionCode(first);
				}
				%>
				Link.addNewItem(members, new Item('G', <%=group.getId()%>, '<%=HTML.javaScriptEncode(group.getName())%> [<%=permissionString%>]', <%=permissionCode%>));
				<%
			}
			%>
			Link.addNewSection(members, new Section('P', 'Projects'));
			<%
			projects = projectQuery.iterate(dc);
			while (projects.hasNext())
			{
				Project project = projects.next();
				Map<ProjectKey, Set<Permission>> p = mp.getPermissions(project);
				String permissionString = "varying";
				int permissionCode = 0;
				if (MultiPermissions.allSame(p.values()))
				{
					Set<Permission> first = p.values().iterator().next();
					permissionString = getPermissionString(first);
					permissionCode = PermissionUtil.getPermissionCode(first);
				}
				%>
				Link.addNewItem(members, new Item('P', <%=project.getId()%>, '<%=HTML.javaScriptEncode(project.getName())%> [<%=permissionString%>]', <%=permissionCode%>));
				<%
			}
			%>
		}
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['share'];
			frm.modifiedUsers.value = Link.exportModified(frm, 'U').join(',');
			frm.modifiedGroups.value = Link.exportModified(frm, 'G').join(',');
			frm.modifiedProjects.value = Link.exportModified(frm, 'P').join(',');
			frm.submit();
		}
		function correctPermissions(checked)
		{
			var frm = document.forms['share'];
			if (checked)
			{
				frm['set_permission'].checked = frm['set_permission'].checked;
				frm['set_owner'].checked = frm['set_owner'].checked;
				frm['delete'].checked = frm['delete'].checked ;
				frm['write'].checked = frm['write'].checked || frm['delete'].checked || frm['set_owner'].checked || frm['set_permission'].checked;
				frm['use'].checked = frm['use'].checked || frm['write'].checked;
				frm['read'].checked = frm['read'].checked || frm['use'].checked;
			}
			else
			{
				frm['read'].checked = frm['read'].checked;
				frm['use'].checked = frm['use'].checked && frm['read'].checked;
				frm['write'].checked = frm['write'].checked && frm['use'].checked;
				frm['delete'].checked = frm['delete'].checked && frm['write'].checked;
				frm['set_owner'].checked = frm['set_owner'].checked && frm['write'].checked;
				frm['set_permission'].checked = frm['set_permission'].checked && frm['write'].checked;
			}
		}
		function getPermissionCode()
		{
			var permissionCode = 0;
			var frm = document.forms['share'];
			permissionCode += frm['read'].checked ? <%=READ_CODE%>: 0;
			permissionCode += frm['use'].checked ? <%=USE_CODE%>: 0;
			permissionCode += frm['write'].checked ? <%=WRITE_CODE%>: 0;
			permissionCode += frm['delete'].checked ? <%=DELETE_CODE%>: 0;
			permissionCode += frm['set_owner'].checked ? <%=SET_OWNER_CODE%>: 0;
			permissionCode += frm['set_permission'].checked ? <%=SET_PERMISSION_CODE%>: 0;
			return permissionCode;
		}
		function getPermissionString(permissionCode)
		{
			var s = '';
			s += permissionCode & <%=READ_CODE%> ? "R" : "-";
			s += permissionCode & <%=USE_CODE%> ? "U" : "-";
			s += permissionCode & <%=WRITE_CODE%> ? "W" : "-";
			s += permissionCode & <%=DELETE_CODE%> ? "D" : "-";
			s += permissionCode & <%=SET_OWNER_CODE%> ? "O" : "-";
			s += permissionCode & <%=SET_PERMISSION_CODE%> ? "P" : "-";
			return s;
		}
		function showPermissions(permissionCode, disabled)
		{
			var frm = document.forms['share'];
			frm['read'].checked = permissionCode & <%=READ_CODE%>;
			frm['use'].checked = permissionCode & <%=USE_CODE%>;
			frm['write'].checked = permissionCode & <%=WRITE_CODE%>;
			frm['delete'].checked = permissionCode & <%=DELETE_CODE%>;
			frm['set_owner'].checked = permissionCode & <%=SET_OWNER_CODE%>;
			frm['set_permission'].checked = permissionCode & <%=SET_PERMISSION_CODE%>;
			frm['read'].disabled = disabled;
			frm['use'].disabled = disabled;
			frm['write'].disabled = disabled;
			frm['delete'].disabled = disabled;
			frm['set_owner'].disabled = disabled;
			frm['set_permission'].disabled = disabled;
			if (disabled)
			{
				Main.show('share_disabled');
			}
			else
			{
				Main.hide('share_disabled');
			}
		}
		
		function permissionsOnClick(name)
		{
			var frm = document.forms['share'];
			var radio = frm[name];
			correctPermissions(radio.checked);
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			for (var i = 0; i < frm.members.length; i++)	// >
			{
				var option = frm.members[i];
				if (option.selected && option.item && option.item.id)
				{
					var item = option.item;
					var disabled = item.id == everyone_id && item.type == 'G' && !share_to_everyone;
					if (!disabled)
					{
						option.item.value = permissionCode;
						var text = option.text.replace(/\[.*\]/, '['+permissionString+']');
						option.text = text; 
					}
				}
			}
		}
	
		function membersOnChange()
		{
			var frm = document.forms['share'];
			var item = frm.members[frm.members.selectedIndex].item;
			if (item && item.id)
			{
				var disabled = item.id == everyone_id && item.type == 'G' && !share_to_everyone;
				showPermissions(item.value, disabled);
			}
		}

		function addUsersOnClick()
		{
			var ids = Link.getListIds(document.forms['share'].members, 'U');
			var excludes = ids.join(',');
			Main.openPopup('../../admin/users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addUserCallback&permission=READ&exclude='+excludes, 'AddUsers', 1000, 700);
		}
		function addUserCallback(userId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('U', userId);
			if (!item) item = new Item('U', userId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['share'].members, item);
		}
		function addGroupsOnClick()
		{
			var ids = Link.getListIds(document.forms['share'].members, 'G');
			<%
			if (!sc.hasSystemPermission(Permission.SHARE_TO_EVERYONE))
			{
				%>
				ids[ids.length] = '<%=SystemItems.getId(Group.EVERYONE)%>';
				<%
			}
			%>
			var excludes = ids.join(',');
			Main.openPopup('../../admin/groups/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addGroupCallback&permission=READ&exclude='+excludes, 'AddGroups', 1000, 700);
		}
		function addGroupCallback(groupId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('G', groupId);
			if (!item) item = new Item('G', groupId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['share'].members, item);
		}
		function addProjectsOnClick()
		{
			var ids = Link.getListIds(document.forms['share'].members, 'P');
			var excludes = ids.join(',');
			Main.openPopup('../../my_base/projects/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addProjectCallback&exclude='+excludes, 'AddProjects', 1000, 700);
		}
		function addProjectCallback(projectId, name)
		{
			var permissionCode = getPermissionCode();
			var permissionString = getPermissionString(permissionCode);
			var item = Link.getItem('P', projectId);
			if (!item) item = new Item('P', projectId, name+' ['+permissionString+']', permissionCode, 0);
			Link.addItem(document.forms['share'].members, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['share'].members);
		}
		</script>
	</base:head>
	<base:body onload="<%="initList()"%>">
		<form name="share" action="submit_share.jsp" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="Save">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext%>">
	
		<h3 class="docked"><%=headLine%> <base:help helpid="share.setpermissions" /></h3>
		<div class="boxed" >
		<table border=0 cellspacing=0 cellpadding=2 width="100%">
		<tr valign="top">
			<td rowspan="2">
				<b>Members</b><br>
				<select name="members" size="15" multiple onChange="membersOnChange()" style="width: 22em;" <%=!writePermission ? "disabled readonly class=\"disabled\"" : ""%>>
				</select>
				<input type="hidden" name="modifiedUsers" value="">
				<input type="hidden" name="modifiedGroups" value="">
				<input type="hidden" name="modifiedProjects" value="">
			</td>
	
			<td><br>
				<b>Permissions</b><br>
				<input type="checkbox" checked name="read" onClick="permissionsOnClick('read')">Read<br>
				<input type="checkbox" checked name="use" onClick="permissionsOnClick('use')">Use<br>
				<input type="checkbox" name="write" onClick="permissionsOnClick('write')">Write<br>
				<input type="checkbox" name="delete" onClick="permissionsOnClick('delete')">Delete<br>
				<input type="checkbox" name="set_owner" onClick="permissionsOnClick('set_owner')">Set owner<br>
				<input type="checkbox" name="set_permission" onClick="permissionsOnClick('set_permission')">Set permission<br>
			</td>
			
			<td>
				<br>
				<table width="150">
				<tr><td><base:button 
					onclick="addUsersOnClick()" 
					title="Add&nbsp;users&hellip;" 
					tooltip="Add users"
					disabled="<%=!writePermission %>" 
					/></td></tr>
				<tr><td><base:button 
					onclick="addGroupsOnClick()" 
					title="Add&nbsp;groups&hellip;"  
					tooltip="Add groups"
					disabled="<%=!writePermission %>" 
				/></td></tr>
				<tr><td><base:button 
					onclick="addProjectsOnClick()" 
					title="Add&nbsp;projects&hellip;" 
					tooltip="Add projects"
					disabled="<%=!writePermission %>" 
					/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the selected items from this group"
					disabled="<%=!writePermission%>" 
				/></td></tr>
				</table>
			</td>
		</tr>
		<tr>
			<td colspan="2">
			<%
			if (hasDirectory)
			{
				%>
				<input type="checkbox" name="recursive" value="1">
				Apply permissions to all subdirectories and their files
				<%
			}
			%>
			</td>
		</tr>
		</table>
		</div>
		</form>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings();" title="Ok" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>

			<div class="error" id="share_disabled" style="display:none;">
				You don't have permission to change permissions for the 
				Everyone group. Please contact you server administrator
				if you think you should have that permission.
			</div>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (users != null) users.close();
	if (groups != null) groups.close();
	if (projects != null) projects.close();
	if (dc != null) dc.close();
}
%>
