<%-- $Id: show_exception.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to display the progress of a file upload. The FileUploadProgress
	is put into the session setting by the upload.jsp page when the upload is started.
	If an exception is thrown during the upload we can get it by checking the
	FileUploadProgress.getException() method. 
	
	If we want to abort the upload we use the FileUpload.setAbort() method, which is
	detected by the upload process and causes an UploadAbortedException to be thrown.
	This exception is also detected by the FileUploadProgress.getException() method
	before we display the message about the aborted upload.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.fileupload.FileUploadProgress"
	import="net.sf.basedb.clients.web.fileupload.UploadAbortedException"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final FileUploadProgress progress = (FileUploadProgress)sc.getSessionSetting("FileUploadProgress");
sc.setSessionSetting("FileUploadProgress", null);
sc.setSessionSetting("UnpackProgress", null);
if (progress.getException() != null) throw progress.getException();
%>
