<%-- $Id: view_well.jsp 4698 2008-12-10 13:59:34Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.WELL;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final Well well = Well.getById(dc, itemId);
	final Plate plate = well.getPlate();
	final ReporterData reporter = well.getReporter();
	final int plateId = plate.getId();

	Well parentWell = null;
	boolean readParentWell = true;
	Plate parentWellPlate = null;
	boolean readParentWellPlate = true;
	try
	{
		parentWell = well.getParent();
	}
	catch (PermissionDeniedException ex)
	{
		readParentWell = false;
		readParentWellPlate = false;
	}
	if (parentWell != null)
	{
		try
		{
			parentWellPlate = parentWell.getPlate();
		}
		catch (PermissionDeniedException ex)
		{
			readParentWellPlate = false;
		}
	}
	
	final boolean writePermission = well.hasPermission(Permission.WRITE);
	final boolean deletePermission = well.hasPermission(Permission.DELETE);
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&plate_id=<%=plateId%>&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Plates" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement 
				title="<%=HTML.encodeTags(plate.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&plate_id="+plateId%>" />
			<p:pathelement title="<%="Well: ["+well.getRow()+", "+well.getColumn()+"]"%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this event type" : "You do not have permission to edit this event type"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'well.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
			
		<div class="boxedbottom">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Row</td>
				<td><%=well.getRow()%></td>
			</tr>
			<tr>
				<td class="prompt">Column</td>
				<td><%=well.getColumn()%></td>
			</tr>
			<tr>
				<td class="prompt">Parent plate/well</td>
				<td>
					<%
					if (!readParentWell)
					{
						%>
						<i>- denied -</i>
						<%
					}
					else if (parentWell == null)
					{
						%>
						<i>- none -</i>
						<%
					}
					else
					{
						%>
						<%=Base.getLink(ID, parentWellPlate.getName() + " [" + parentWell.getRow() + ", " + parentWell.getColumn() + "]",
							Item.WELL, parentWell.getId(), true) %>
						<%
					}
					%>
				</td>
			</tr>
			</table>
			
			<h4>Reporter</h4>
			<%
			if (reporter == null)
			{
				%>
				<i>- none -</i>
				<%
			}
			else
			{
				boolean readCurrentReporterType = true;
				ReporterType currentReporterType = null;
				try
				{
					currentReporterType = Reporter.getReporterType(dc, reporter);
				}
				catch (PermissionDeniedException ex)
				{
					readCurrentReporterType = false;
				}
				%>
				<table border="0" cellspacing="0" cellpadding="0">
				<tr valign="top">
				<td>
					<table class="form" cellspacing=0>
					<tr>
						<td class="prompt">Name</td>
						<td><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), true) %></td>
					</tr>
					<tr>
						<td class="prompt">Registered</td>
						<td><%=dateFormatter.format(reporter.getEntryDate())%></td>
					</tr>
					<tr>
						<td class="prompt">Last update</td>
						<td><%=dateTimeFormatter.format(reporter.getLastUpdate())%></td>
					</tr>
					<tr>
						<td class="prompt">External ID</td>
						<td><%=HTML.encodeTags(reporter.getExternalId())%></td>
					</tr>
					<tr>
						<td class="prompt">Type</td>
						<td><%=Base.getEncodedName(currentReporterType, !readCurrentReporterType)%></td>
					</tr>
					<tr>
						<td class="prompt">Gene symbol</td>
						<td><%=HTML.encodeTags(reporter.getSymbol())%></td>
					</tr>
					<tr valign="top">
						<td class="prompt">Description</td>
						<td><%=HTML.niceFormat(reporter.getDescription())%></td>
					</tr>
					</table>
				</td>
				<td>&nbsp;&nbsp;</td>
				<td>
					<table class="form" cellspacing=0>
						<%
						List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
						if (reporterProperties != null)
						{
							boolean needsTr = true;
							for (ExtendedProperty ep : reporterProperties)
							{
								String name = ep.getName();
								Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
								String value = f.format(reporter.getExtended(name));
								%>
									<%=needsTr ? "<tr valign=\"top\">" : "" %>
									<td class="prompt"><%=HTML.encodeTags(ep.getTitle())%></td>
									<td><%=value%></td>
									<td>&nbsp;&nbsp;</td>
									<%=needsTr ? "" : "</tr>"%>
								<%
								needsTr = !needsTr;
							}
							%>
							<%=needsTr ? "" : "</tr>"%>
							<%
						}
						%>
					</table>
				</td>
				</tr>
				</table>
				<%
			}
			%>
		</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" >
				<div class="boxed">
				<jsp:include page="../../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
