<%-- $Id: edit_experiment.jsp 4711 2008-12-18 08:22:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Arrays"
	import="java.util.Date"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.EXPERIMENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Experiment experiment = null;
	RawDataType currentRawDataType = null;
	RawDataType defaultRawDataType = null;
	ItemQuery<RawBioAssay> rbaQuery = null;
	ItemQuery<AnnotationType> efQuery = null;
	
	boolean readCurrentDirectory = true;
	Directory currentDirectory = null;

	List<Directory> recentDirectories = (List<Directory>)cc.getRecent(dc, Item.DIRECTORY);

	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);		
		defaultRawDataType = activeProject.getDefaultRawDataType();
	}	
	if (itemId == 0)
	{
		title = "Create experiment";
		currentRawDataType = RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
		if (currentRawDataType == null)
		{
			currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
		}
		if (cc.getPropertyFilter("directory.name") != null)
		{
			currentDirectory = Base.getFirstMatching(dc, Directory.getQuery(), "name", cc.getPropertyFilter("directory.name"));
		}
		cc.removeObject("item");
		String[] selected = request.getParameterValues("rawbioassay_id");
		if (selected != null)
		{
			rbaQuery = RawBioAssay.getQuery();
			rbaQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			rbaQuery.setParameter("selected", Arrays.asList(Values.getInt(selected)), Type.INT);
		}		
	}
	else
	{
		experiment = Experiment.getById(dc, itemId);
		rbaQuery = experiment.getRawBioAssays();
		efQuery = experiment.getExperimentalFactors();
		cc.setObject("item", experiment);
		try
		{
			currentRawDataType = experiment.getRawDataType();
		}
		catch (Throwable t)
		{}
		title = "Edit experiment -- " + HTML.encodeTags(experiment.getName());
		try
		{
			currentDirectory = experiment.getDirectory();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentDirectory = false;
		}
	}
	if (experiment != null) experiment.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Experiment" tab
		function validateExperiment()
		{
			var frm = document.forms['experiment'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.rawdatatype)
			{
				if (frm.rawdatatype[frm.rawdatatype.selectedIndex].value == '')
				{
					alert("You must select a raw data type");
					frm.rawdatatype.focus();
					return false;
				}
			}
			return true;
		}
		
		// Validate the "Experimental factors" tab
		function validateExperimentalFactors()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['experiment'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addedRawBioAssays.value = Link.getActionIds(1, 'R').join(',');
				frm.removedRawBioAssays.value = Link.getActionIds(-1, 'R').join(',');

				frm.addedAnnotationTypes.value = Link.getActionIds(1, 'A').join(',');
				frm.removedAnnotationTypes.value = Link.getActionIds(-1, 'A').join(',');
				
				frm.submit();
			}
		}
		
		function addRawBioAssaysOnClick()
		{
			var frm = document.forms['experiment'];
			var ids = Link.getListIds(frm.rawBioAssays, 'R');
			var excludes = ids.join(',');
			var rawDataType = <%=currentRawDataType == null ? "frm.rawdatatype[frm.rawdatatype.selectedIndex].value" : "'"+currentRawDataType.getId()+"'"%>;
			var url = '../rawbioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addRawBioAssayCallback';
			url += "&exclude="+excludes;
			url += '&filter:STRING:rawDataType='+rawDataType;
			Main.openPopup(url, 'AddRawBioAssays', 1000, 700);
		}
		function addRawBioAssayCallback(rawBioAssayId, name)
		{
			var item = Link.getItem('R', rawBioAssayId);
			if (!item) item = new Item('R', rawBioAssayId, name);
			Link.addItem(document.forms['experiment'].rawBioAssays, item);
		}
		function removeRawBioAssaysOnClick()
		{
			Link.removeSelected(document.forms['experiment'].rawBioAssays);
		}
		
		function addAnnotationTypesOnClick()
		{
			var frm = document.forms['experiment'];
			var ids = Link.getListIds(frm.annotationTypes, 'A');
			var excludes = ids.join(',');
			var url = '../../admin/annotationtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAnnotationTypeCallback';
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddAnnotationTypes', 1000, 700);
		}
		function addAnnotationTypeCallback(annotationTypeId, name)
		{
			var item = Link.getItem('A', annotationTypeId);
			if (!item) item = new Item('A', annotationTypeId, name);
			Link.addItem(document.forms['experiment'].annotationTypes, item);
		}
		function removeAnnotationTypesOnClick()
		{
			Link.removeSelected(document.forms['experiment'].annotationTypes);
		}
		function selectDirectoryOnClick()
		{
			var frm = document.forms['experiment'];
			var url = '../../filemanager/directories/index.jsp?ID=<%=ID%>&mode=selectonedirectory&callback=setDirectoryCallback';
			if (frm.directory_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.directory_id[1].value));				
				url += '&directory_id='+id;
			}
			Main.openPopup(url, 'SelectDirectory', 350, 500);
		}
		function setDirectoryCallback(id, name)
		{
			var frm = document.forms['experiment'];
			var list = frm.directory_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['experiment'];
			<%
			if (experiment == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			if (rbaQuery != null)
			{
				%>
				var rawBioAssays = frm.rawBioAssays;
				<%
				rbaQuery.include(Include.ALL);
				rbaQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<RawBioAssay> rawBioAssays = rbaQuery.list(dc);
				if (rawBioAssays.size() > 0 && experiment == null) currentRawDataType = null;
				for (RawBioAssay rba : rawBioAssays)
				{
					RawDataType rbaDataType = null;
					try
					{
						rbaDataType = rba.getRawDataType();
					}
					catch (Throwable t)
					{}
					if (currentRawDataType == null) 
					{
						currentRawDataType = rbaDataType;
					}
					String linkMethod = "addNewItem";
					if (experiment == null)
					{
						linkMethod = "addItem";
						// Checks for new experiment
						if (rbaDataType != currentRawDataType)
						{
							throw new WebException("popup", "Raw data types doesn't match",
								"The raw data type of the selected raw bioassays are not the same. " + 
								"It is not possible to mix raw data types in an experiment.");
						}
					}
					%>
					Link.<%=linkMethod%>(rawBioAssays, new Item('R', <%=rba.getId()%>, '<%=HTML.javaScriptEncode(rba.getName())%>'));
					<%
				}
			}
			if (efQuery != null)
			{
				%>
				var annotationTypes = frm.annotationTypes;
				<%
				efQuery.include(Include.ALL);
				efQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
				for (AnnotationType at : experimentalFactors)
				{
					%>
					Link.addNewItem(annotationTypes, new Item('A', <%=at.getId()%>, '<%=HTML.javaScriptEncode(at.getName())%>'));
					<%
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="experiment" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" remember="<%=experiment != null%>">
		<t:tab id="info" title="Experiment" validate="validateExperiment()" helpid="experiment.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(experiment == null ? Values.getString(cc.getPropertyValue("name"), "New experiment") : experiment.getName())%>" 
					size="40" maxlength="<%=Experiment.MAX_NAME_LENGTH%>"></td>
			</tr>
			
			<tr>
				<td class="prompt">Raw data type</td>
				<td>
					<%
					if (experiment == null)
					{
						currentRawDataType = currentRawDataType != null ? 
							currentRawDataType : defaultRawDataType;
						Enumeration<RawDataType, String> rawEnumeration = 
							new Enumeration<RawDataType, String>();
						for (RawDataType rdt : RawDataTypes.getRawDataTypes())
						{
							rawEnumeration.add(rdt, rdt.getName());
						}
						rawEnumeration.sortValues();						
						%>
						<select name="rawdatatype" class="required unchangeable">
						<%
						for (int i = 0; i < rawEnumeration.size(); ++i)
						{
							RawDataType rdt = rawEnumeration.getKey(i);
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
						%>
						</select>
						<%
					}
					else
					{
						%>
						<base:catch><%=HTML.encodeTags(experiment.getRawDataType().getName())%></base:catch>
						<%
					}
					%>
				
				</td>
			</tr>
			<tr>
				<td class="prompt">Directory</td>
				<td>
					<base:select 
						id="directory_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentDirectory%>"
						denied="<%=!readCurrentDirectory%>"
						recent="<%=recentDirectories%>"
						newitem="<%=experiment == null%>"
						onselect="selectDirectoryOnClick()"
					/>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Raw bioassays</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="rawBioAssays" size="5" multiple style="width: 20em;">
						</select>
						<input type="hidden" name="addedRawBioAssays" value="">
						<input type="hidden" name="removedRawBioAssays" value="">
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							onclick="addRawBioAssaysOnClick()" 
							title="Add&nbsp;raw bioassays&hellip;" 
							tooltip="Add raw bioassays"
							/></td></tr>
						<tr><td width="150"><base:button 
							onclick="removeRawBioAssaysOnClick()" 
							title="Remove" 
							tooltip="Remove the selected raw bioassays"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("description") : experiment.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'rawbioassay', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>
				&nbsp;<i><base:icon image="required.gif" /> = required information</i>
				<%if (experiment == null) {%><br>
				<i><base:icon image="unchangeable.gif" /> = can't be changed later</i>
				<%}%>
				</div>
		</t:tab>
		
		<t:tab id="publication" title="Publication"  helpid="experiment.edit.publication">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">PubMedId</td>
				<td><input <%=clazz%> type="text" name="pubMedId" 
					value="<%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("pubMedId") : experiment.getPubMedId())%>" 
					size="40" maxlength="<%=Experiment.MAX_PUBMEDID_LENGTH%>"></td>
			</tr>
				<td class="prompt">Title</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="title" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("title") : experiment.getTitle())%></textarea>
					<a href="javascript:Main.zoom('Title', 'experiment', 'title')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr>
				<td class="prompt">Publication date</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="publicationDate" 
							value="<%=HTML.encodeTags(dateFormatter.format(experiment == null ? 
								(Date)cc.getPropertyObject("publicationDate") : experiment.getPublicationDate()))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Publication date', 'experiment', 'publicationDate', null, '"+jsDateFormat+"')"%>"
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Abstract</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="abstract" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("abstract") : experiment.getAbstract())%></textarea>
					<a href="javascript:Main.zoom('Abstract', 'experiment', 'abstract')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Experiment design</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="experimentDesign" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("experimentDesign") : experiment.getExperimentDesign())%></textarea>
					<a href="javascript:Main.zoom('Experiment design', 'experiment', 'experimentDesign')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Experiment type</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="experimentType" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("experimentType") : experiment.getExperimentType())%></textarea>
					<a href="javascript:Main.zoom('Experiment type', 'experiment', 'experimentType')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Affiliations</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="affiliations" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("affiliations") : experiment.getAffiliations())%></textarea>
					<a href="javascript:Main.zoom('Affiliations', 'experiment', 'affiliations')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Authors</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="authors" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("authors") : experiment.getAuthors())%></textarea>
					<a href="javascript:Main.zoom('Authors', 'experiment', 'authors')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Publication</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="publication" wrap="virtual"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("publication") : experiment.getPublication())%></textarea>
					<a href="javascript:Main.zoom('Publication', 'experiment', 'publication')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			</t:tab>
			
			<t:tab id="experimentalFactors" title="Experimental factors" 
				validate="validateExperimentalFactors()" helpid="experiment.edit.factors">
			<table class="form" cellspacing=0>

			<tr valign="top">
				<td class="prompt">Annotation types</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="annotationTypes" size="10" multiple style="width: 20em;">
						</select>
						<input type="hidden" name="addedAnnotationTypes" value="">
						<input type="hidden" name="removedAnnotationTypes" value="">
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							onclick="addAnnotationTypesOnClick()" 
							title="Add annotation types&hellip;" 
							tooltip="Add annotation types"
							/></td></tr>
						<tr><td width="150"><base:button 
							onclick="removeAnnotationTypesOnClick()" 
							title="Remove" 
							tooltip="Remove the selected annotation types"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
